diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index e66e80d74..3f8f8fc72 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -287,7 +287,7 @@ item.dust.sugar.desc=Can craft sweet treats.
 item.food.cake.name=Cake
 item.food.cake.desc=Not a lie!
 item.food.pumpkin_pie.name=Pumpkin Pie
-item.food.pumpkin_pie.desc=Thanks!
+item.food.pumpkin_pie.desc=The cake is a pie!
 item.bed.name=Bed
 item.bed.desc=Take a nap overnight.
 item.repeater.name=Redstone Repeater
@@ -412,4 +412,7 @@ item.door.glass.name=Glass Door
 item.door.glass.desc=Great for aesthetics, terrible for privacy.
 
 item.rope.name=Rope
-item.rope.desc=Strong enough to climb.
\ No newline at end of file
+item.rope.desc=Strong enough to climb.
+
+item.wand.monster.name=Summoning Wand
+item.wand.monster.desc=A magical tool allowing the wielder to manifest living entities.
\ No newline at end of file
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 1217a7a19..951f1dd42 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -55,6 +55,10 @@ options.slimeParticles=Slime Chunk Particles
 options.3Ditems=3D Items
 options.screenPadding=Screen Padding
 options.gamma=Gamma
+options.brightness=Brightness
+options.brightness.min=Moody
+options.brightness.default=Default
+options.brightness.max=Bright
 options.fxaa=FXAA
 options.placementMode=Placement Mode
 options.placementMode.default=Default
diff --git a/src/common/resources/lang/en_US/strings.lang b/src/common/resources/lang/en_US/strings.lang
index 40b0d9769..35b58ce69 100644
--- a/src/common/resources/lang/en_US/strings.lang
+++ b/src/common/resources/lang/en_US/strings.lang
@@ -132,4 +132,6 @@ sign.image.brb=BRB
 
 flag.full=You have too many flags on this map!
 flag.overwrite=Cannot overwrite an existing pattern.
-flag.copied=Flag pattern copied.
\ No newline at end of file
+flag.copied=Flag pattern copied.
+
+wand.wrongmode=You must be in Creative mode to use this item!
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index d32b21f04..0a9b3b1bb 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -60,6 +60,7 @@ import net.minecraft.client.net.thread.ThreadSleepForeverClient;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.InputDevice;
 import net.minecraft.client.option.KeyBinding;
+import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
 import net.minecraft.client.render.ChunkRenderer;
 import net.minecraft.client.render.EffectRenderer;
@@ -102,6 +103,7 @@ import net.minecraft.core.UnexpectedThrowable;
 import net.minecraft.core.achievement.AchievementList;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.achievement.stat.StatsCounter;
+import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.crafting.legacy.CraftingManager;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.Registries;
@@ -818,6 +820,7 @@ public class Minecraft
                     OpenGLHelper.checkError("pre render");
                     RenderBlocks.fancyGrass = gameSettings.fancyGraphics.value == 1;
                     EntityItem.enableItemClumping = gameSettings.enableItemClumping.value;
+                    BlockLeavesBase.enableTreeShadowing = gameSettings.treeShadows.value;
                     sndManager.updateListenerPosition(thePlayer, timer.partialTicks);
                     glEnable(GL_TEXTURE_2D);
                     if(theWorld != null)
@@ -1325,6 +1328,7 @@ public class Minecraft
                                 ingameGUI.addChatMessage("F3 + F: Toggle fullbright");
                                 ingameGUI.addChatMessage("F3 + G: Show chunk borders");
                                 ingameGUI.addChatMessage("F3 + H: Toggle item durability");
+                                ingameGUI.addChatMessage("F3 + L: Toggle lightmap");
                                 ingameGUI.addChatMessage("F3 + N: Switch gamemode");
                                 ingameGUI.addChatMessage("F3 + P: Toggle pause on lost focus");
                                 ingameGUI.addChatMessage("F3 + R: Reload");
@@ -1381,6 +1385,18 @@ public class Minecraft
                                 }
                                 ingameGUI.guiHeldItemTooltip.setString("Fullbright: " + (fullbright ? "On" : "Off"));
                             }
+                            else if (Keyboard.getEventKey() == Keyboard.KEY_L)
+                            {
+                            	if(gameSettings.lightmapStyle.value == LightmapStyle.DISABLED) {
+                            		gameSettings.lightmapStyle.value = LightmapStyle.DEFAULT;
+                            		ingameGUI.guiHeldItemTooltip.setString("Lightmap: On");
+                            		renderGlobal.loadRenderers();
+                            	}else {
+                            		gameSettings.lightmapStyle.value = LightmapStyle.DISABLED;
+                            		ingameGUI.guiHeldItemTooltip.setString("Lightmap: Off");
+                            		renderGlobal.loadRenderers();
+                            	}
+                            }
                             else if (Keyboard.getEventKey() == Keyboard.KEY_B)
                             {
                             	gameSettings.showCollisionBoxes.toggle();
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
index e88af6d34..009811c7b 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.entity.fx;
 
+import net.minecraft.client.render.LightmapHelper;
+
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Block, TessellatorStandard, World
 
@@ -57,8 +59,13 @@ public class EntityDiggingFX extends EntityFX
         float f11 = (float)((xo + (x - xo) * (double) partialTick) - lerpPosX);
         float f12 = (float)((yo + (y - yo) * (double) partialTick) - lerpPosY);
         float f13 = (float)((zo + (z - zo) * (double) partialTick) - lerpPosZ);
-        float f14 = getBrightness(partialTick);
-        t.setColorOpaque_F(f14 * particleRed, f14 * particleGreen, f14 * particleBlue);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(brightness * particleRed, brightness * particleGreen, brightness * particleBlue);
         t.addVertexWithUV(f11 - rotationX * f10 - rotationYZ * f10, f12 - rotationXZ * f10, f13 - rotationZ * f10 - rotationXY * f10, f6, f9);
         t.addVertexWithUV((f11 - rotationX * f10) + rotationYZ * f10, f12 + rotationXZ * f10, (f13 - rotationZ * f10) + rotationXY * f10, f6, f8);
         t.addVertexWithUV(f11 + rotationX * f10 + rotationYZ * f10, f12 + rotationXZ * f10, f13 + rotationZ * f10 + rotationXY * f10, f7, f8);
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
index a2a923c92..8e1a36204 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.entity.fx;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
@@ -106,7 +107,12 @@ public class EntityFX extends Entity
         float posX = (float)((xo + (this.x - xo) * (double)partialTick) - lerpPosX);
         float posY = (float)((yo + (this.y - yo) * (double)partialTick) - lerpPosY);
         float posZ = (float)((zo + (this.z - zo) * (double)partialTick) - lerpPosZ);
-        float brightness = getBrightness(partialTick);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
         t.setColorOpaque_F(particleRed * brightness, particleGreen * brightness, particleBlue * brightness);
         t.addVertexWithUV(posX - rotationX * scale - rotationYZ * scale, posY - rotationXZ * scale, posZ - rotationZ * scale - rotationXY * scale, texMaxU, texMaxV);
         t.addVertexWithUV((posX - rotationX * scale) + rotationYZ * scale, posY + rotationXZ * scale, (posZ - rotationZ * scale) + rotationXY * scale, texMaxU, texMinV);
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityFireflyFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityFireflyFX.java
index b3a6d57b9..d774fde68 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityFireflyFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityFireflyFX.java
@@ -2,6 +2,7 @@ package net.minecraft.client.entity.fx;
 
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.animal.EntityFireflyCluster;
 import net.minecraft.core.util.helper.MathHelper;
@@ -124,13 +125,23 @@ public class EntityFireflyFX extends EntityFX
         float scale = 0.1F * particleScale;
         float posX = (float)(xo + (x - xo) * partialTick);
         float posY = (float)(yo + (y - yo) * partialTick);
-        float brightness = getBrightness(partialTick);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
         t.setColorOpaque_F(particleRed * brightness, particleGreen * brightness, particleBlue * brightness);
         t.addVertexWithUV(posX + scale, posY - scale, 0, texMaxU, texMaxV);
         t.addVertexWithUV(posX + scale, posY + scale, 0, texMaxU, texMinV);
         t.addVertexWithUV(posX - scale, posY + scale, 0, texMinU, texMinV);
         t.addVertexWithUV(posX - scale, posY - scale, 0, texMinU, texMaxV);
     }
+    
+    @Override
+    public int getLightmapCoord(float partialTicks) {
+    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTicks), 15);
+    }
 
     public void tickGUI() {
         sinTimer++;
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityFlameFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityFlameFX.java
index 015131549..76c45f27e 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityFlameFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityFlameFX.java
@@ -4,6 +4,7 @@ package net.minecraft.client.entity.fx;
 //            EntityFX, World, TessellatorStandard
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
@@ -43,6 +44,11 @@ public class EntityFlameFX extends EntityFX
         float decay = MathHelper.clamp(((float)particleAge + partialTick) / (float)particleMaxAge, 0.0f, 1.0f);
         return super.getBrightness(partialTick) * decay + (1.0F - decay);
     }
+    
+    @Override
+    public int getLightmapCoord(float partialTicks) {
+    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTicks), 15);
+    }
 
     @Override
 	public void tick()
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
index 45824e61c..669b12bd4 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
@@ -16,6 +16,7 @@ import net.minecraft.client.gui.GuiFurnace;
 import net.minecraft.client.gui.GuiPaintingPicker;
 import net.minecraft.client.gui.GuiPickMonster;
 import net.minecraft.client.gui.GuiTrommel;
+import net.minecraft.client.gui.GuiWandPickerMonster;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.AchievementList;
@@ -229,9 +230,9 @@ public class EntityPlayerSP extends EntityPlayer
         }
         super.onLivingUpdate();
 
-        if (Minecraft.getMinecraft(this) != null)
+        if (mc != null)
         {
-            Minecraft.getMinecraft(this).ppm.update();
+           mc.ppm.update();
         }
     }
     
@@ -303,6 +304,11 @@ public class EntityPlayerSP extends EntityPlayer
         String currentMobId = ((TileEntityMobSpawner) world.getBlockTileEntity(x, y, z)).getMobId();
         mc.displayGuiScreen(new GuiPickMonster(currentMobId, x, y, z));
     }
+    @Override
+    public void displayGUIWandMonsterPicker(ItemStack stack) {
+        String currentMobId = stack.getData().getStringOrDefault("monster", "Pig");
+        mc.displayGuiScreen(new GuiWandPickerMonster(currentMobId, stack));
+    }
 
     @Override
     public void displayGUIFurnace(TileEntityFurnace tileentityfurnace)
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java b/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java
index 5fd8099c4..8c6f53089 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java
@@ -108,7 +108,7 @@ public class GuiIngameMenu extends GuiScreen
         I18n i = I18n.getInstance();
         drawDefaultBackground();
         if(mc == null || mc.theWorld == null) {
-        	Minecraft.getMinecraft(this).displayGuiScreen(null);
+        	mc.displayGuiScreen(null);
         	return;
         }
         boolean isSaving = !mc.theWorld.pauseScreenSave(updateCounter2++);
diff --git a/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java b/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
new file mode 100644
index 000000000..93585cd1a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
@@ -0,0 +1,80 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.packet.Packet250CustomPayload;
+
+import java.lang.reflect.Modifier;
+import java.nio.charset.StandardCharsets;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+public class GuiWandPickerMonster extends GuiScreen {
+    private String mobId;
+    private boolean shouldClose = false;
+    private final ItemStack wand;
+
+
+    public GuiWandPickerMonster(String mobId, ItemStack itemStack) {
+        this.mobId = mobId;
+        wand = itemStack;
+    }
+
+    @Override
+    public void init() {
+        List<String> monsters = new ArrayList<>();
+        for (Class<? extends Entity> clazz : EntityDispatcher.classToKeyMap.keySet()) {
+            if (EntityLiving.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
+                monsters.add(EntityDispatcher.classToKeyMap.get(clazz));
+            }
+        }
+        Collections.sort(monsters);
+        List<String> prettyMonsters = new ArrayList<>();
+        for (String monster : monsters) {
+            StringBuilder sb = new StringBuilder();
+            for (char c : monster.toCharArray()) {
+                if (Character.isUpperCase(c)) {
+                    sb.append(' ');
+                }
+                sb.append(c);
+            }
+            prettyMonsters.add(sb.toString());
+        }
+
+        GuiPopup popup = new PopupBuilder(this, 150)
+                .withLabel("gui.pick_monster.label.title")
+                .withList("list", 140, prettyMonsters.toArray(new String[0]), null, -1, true)
+                .closeOnEsc(0)
+                .closeOnClickOut(0)
+                .withOnCloseListener((statusCode, results) -> {
+                    if (statusCode == 1) {
+                        mobId = monsters.get((Integer) results.get("list"));
+                        if (!mc.theWorld.isClientSide) {
+                            wand.getData().putString("monster", mobId);
+                        } else {
+                            mc.getSendQueue().addToSendQueue(new Packet250CustomPayload("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
+                        }
+                    }
+                    shouldClose = true;
+                })
+                .build();
+        mc.displayGuiScreen(popup);
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+        if (shouldClose) {
+            mc.displayGuiScreen(null);
+        }
+    }
+
+    public String getMobId() {
+        return mobId;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index 86d19359f..7765d0baa 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -251,8 +251,6 @@ public class MobPage
 
         float heightFactor = 50f / 1.8f;
 
-        Minecraft mc = Minecraft.getMinecraft(this);
-
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         Scissor.enable(x + 9, y + 9, 52, 70);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
index bd567155b..c0f43b63f 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
@@ -87,8 +87,9 @@ public class MobSection
 
         @Override
         public String getName() {
-            boolean discovered = Minecraft.getMinecraft(this).statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.classToKeyMap.get(mobInfo.getEntityClass()))) > 0;
-            if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.creative) discovered = true;
+        	Minecraft mc = Minecraft.getMinecraft(this);
+            boolean discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.classToKeyMap.get(mobInfo.getEntityClass()))) > 0;
+            if (mc.thePlayer.getGamemode() == Gamemode.creative) discovered = true;
 
             if (discovered) {
                 return I18n.getInstance().translateKey(mobInfo.getNameTranslationKey());
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
index 1551922d5..f0ac1a7cf 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
@@ -26,7 +26,7 @@ public class DispatcherEntry extends EntityEntry<Entity> {
 
     @Override
     public Entity getEntityInstance(Minecraft mc, World world) {
-        return EntityDispatcher.createEntityInWorld(id, Minecraft.getMinecraft(this).theWorld);
+        return EntityDispatcher.createEntityInWorld(id, mc.theWorld);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index f009d8cd9..a651ccf00 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -83,6 +83,7 @@ public class LanguagePackListComponent
     }
 
     private static class LanguagePackComponent {
+    	private Minecraft mc = Minecraft.getMinecraft(this);
         public final int index;
         public final Language languagePack;
         public final int height = BUTTON_HEIGHT;
@@ -93,7 +94,7 @@ public class LanguagePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
-            FontRenderer textRenderer = Minecraft.getMinecraft(this).fontRenderer;
+            FontRenderer textRenderer = mc.fontRenderer;
             TessellatorStandard tessellator = TessellatorStandard.instance;
 
             if (mc.gameSettings.language.value.equals(languagePack.getId())) {
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 8bf33c70c..78835f997 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -92,6 +92,7 @@ public abstract class OptionsPages
         )
         .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
             .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle))
+            .withComponent(new FloatOptionComponent(mc.gameSettings.brightness))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.biomeWater))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.treeShadows))
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index e88aace56..01be9a240 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -47,6 +47,7 @@ public class GameSettings {
 	public FloatOption mouseSensitivity = new FloatOption(this, "mouseSensitivity", 0.5f);
 	public FloatOption screenPadding = new FloatOption(this, "screenPadding", 0.0f);
 	public FloatOption gamma = new FloatOption(this, "gamma", 0.5f);
+	public FloatOption brightness = new FloatOption(this, "brightness", 0.5f);
 
 	public FloatOption fxaa = new FloatOption(this, "fxaa", 0.0f);
 	public FloatOption controllerSensitivity = new FloatOption(this, "controllerSensitivity", 0.5f);
@@ -238,47 +239,59 @@ public class GameSettings {
 			return trans.translateKey("options.borderlessFullscreen.unavailable");
 		}
 		if (option instanceof FloatOption) {
-			Float f = (Float) option.value;
+			float value = (float) option.value;
+			if (option == brightness) {
+				int percent = (int)(value * 200.0f);
+				if (percent == 0) {
+					return trans.translateKey("options.brightness.min");
+				}else if (percent == 100) {
+					return trans.translateKey("options.brightness.default");
+				}else if (percent == 200) {
+					return trans.translateKey("options.brightness.max");
+				}else {
+					return percent + "%";
+				}
+			}
 			if (option == mouseSensitivity) {
-				if (f == 0.0F) {
+				if (value == 0.0F) {
 					return trans.translateKey("options.mouseSensitivity.min");
 				}
-				if (f == 1.0F) {
+				if (value == 1.0F) {
 					return trans.translateKey("options.mouseSensitivity.max");
 				} else {
-					return (int) (f * 200F) + "%";
+					return (int) (value * 200F) + "%";
 				}
 			}
 			if (option == FoV) {
-				if (f == 0) {
+				if (value == 0) {
 					return trans.translateKey("options.fov.min");
 				}
-				if (f == 1) {
+				if (value == 1) {
 					return trans.translateKey("options.fov.max");
 				} else {
-					return (int) (f * 100 + 30) + "°";
+					return (int) (value * 100 + 30) + "°";
 				}
 			}
 			if (option == screenPadding) {
-				int percent = (int) (f * 100);
+				int percent = (int) (value * 100);
 				return percent + "%";
 			}
 			if (option == gamma) {
-				int percent = (int) (f * 200);
+				int percent = (int) (value * 200);
 				return percent + "%";
 			}
 			if (option == autosaveTimer) {
-				int timer = (int) (f * 24);
+				int timer = (int) (value * 24);
 				if (timer == 0) {
 					return trans.translateKey("options.autosaveTimer.off");
 				} else {
 					return (timer * 5) + " seconds";
 				}
 			}
-			if (f == 0.0F) {
+			if (value == 0.0F) {
 				return trans.translateKey("options.off");
 			} else {
-				return (int) (f * 100F) + "%";
+				return (int) (value * 100F) + "%";
 			}
 		}
 		if (option == guiScale) {
